//
// XRXHeader.h
//
// Includes some global things for interoperability
//

#ifndef XRX_JS_HEADER
#define XRX_JS_HEADER

#define DLL_PUBLIC __attribute__ ((visibility ("default")))

//extern "C" DLL_PUBLIC void *(*exit_cui_routine) (void *); 


typedef void *(*XRXJavascriptHook) (void *);
typedef unsigned long (*XRXJavascriptIntReturningHook) (void);

class DLL_PUBLIC XRXGlobals
{
private:
    static XRXJavascriptHook exit_cui_routine;
    static XRXJavascriptIntReturningHook EipGetHeapAvailable_routine;
    static XRXJavascriptIntReturningHook EipGetFlexAvailable_routine;
    static XRXJavascriptIntReturningHook EipGetHeapAllocated_routine;
    static XRXJavascriptIntReturningHook EipGetFlexAllocated_routine;
public:
    static DLL_PUBLIC void setExitCUIAction( XRXJavascriptHook routine);
    static DLL_PUBLIC XRXJavascriptHook getExitCUIAction();

    static DLL_PUBLIC void setEipGetHeapAvailableAction( XRXJavascriptIntReturningHook routine);
    static DLL_PUBLIC void setEipGetFlexAvailableAction( XRXJavascriptIntReturningHook routine);
    static DLL_PUBLIC void setEipGetHeapAllocatedAction( XRXJavascriptIntReturningHook routine);
    static DLL_PUBLIC void setEipGetFlexAllocatedAction( XRXJavascriptIntReturningHook routine);
    static DLL_PUBLIC XRXJavascriptIntReturningHook getEipGetHeapAvailableAction();
    static DLL_PUBLIC XRXJavascriptIntReturningHook getEipGetFlexAvailableAction();
    static DLL_PUBLIC XRXJavascriptIntReturningHook getEipGetHeapAllocatedAction();
    static DLL_PUBLIC XRXJavascriptIntReturningHook getEipGetFlexAllocatedAction();
};

#endif
